/*===========================================
	Wiimote Demo
	by shdwcoder
	v1.5 - Using the latest libOGC with Wiimote support
	08/06/2008
	
	Using the great GRRLIB by NoNameNo
===========================================*/
#include <stdio.h>
#include <stdlib.h>
#include <gccore.h>
#include <wiiuse/wpad.h>

#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>

#include "../gfx/impact.h"
#include "../gfx/cursor.h"


#include "GRRLIB.h"
extern u16 *GRRLIB_buffer;

#define GREEN 0x00ff00
#define RED 0xff0000
#define BLUE 0x0000ff


void drawPoint(int x, int y, u32 color32){
	u16 color = GRRLIB_Conv888_565(color32);
	GRRLIB_PutPixel(x-2,y-2,color);
	GRRLIB_PutPixel(x-2,y-1,color);
	GRRLIB_PutPixel(x-2,y,color);
	GRRLIB_PutPixel(x-2,y+1,color);
	GRRLIB_PutPixel(x-2,y+2,color);
	GRRLIB_PutPixel(x-1,y-2,color);
	GRRLIB_PutPixel(x-1,y-1,color);
	GRRLIB_PutPixel(x-1,y,color);
	GRRLIB_PutPixel(x-1,y+1,color);
	GRRLIB_PutPixel(x-1,y+2,color);
	GRRLIB_PutPixel(x,y-2,color);
	GRRLIB_PutPixel(x,y-1,color);
	GRRLIB_PutPixel(x,y,color);
	GRRLIB_PutPixel(x,y+1,color);
	GRRLIB_PutPixel(x,y+2,color);
	GRRLIB_PutPixel(x+1,y-2,color);
	GRRLIB_PutPixel(x+1,y-1,color);
	GRRLIB_PutPixel(x+1,y,color);
	GRRLIB_PutPixel(x+1,y+1,color);
	GRRLIB_PutPixel(x+1,y+2,color);
	GRRLIB_PutPixel(x+2,y-2,color);
	GRRLIB_PutPixel(x+2,y-1,color);
	GRRLIB_PutPixel(x+2,y,color);
	GRRLIB_PutPixel(x+2,y+1,color);
	GRRLIB_PutPixel(x+2,y+2,color);
}
	
void PrintFloat(int x, int y, int xsize, int ysize, float value, const u16 tdata[]){
	
	char text[10];
	sprintf(text, "%1.3f", value);
	GRRLIB_ImgPrint(x, y, xsize, ysize, text, tdata);
}
int main(){
	
	//Vars for pointer
	ir_t  ir;
	orient_t orient;
	int ha;
	GRRLIB_buffer=(u16 *)malloc(640*480*2);	
	
	//Gforce vars
	gforce_t gforce;
	
	VIDEO_Init();

	GRRLIB_InitVideo();
	GRRLIB_Start();

	GRRLIB_FillScreen(0x0000);
	GRRLIB_ImgPrint(172,200,16,16,"LOADING...",impact_img);
	GRRLIB_Render();
	VIDEO_WaitVSync();
	
	// This function initialises the attached controllers
	WPAD_Init();
	WPAD_SetDataFormat(0,WPAD_FMT_BTNS_ACC_IR);
	WPAD_SetVRes(0,640,480);

	// Call WPAD_ScanPads each loop, this reads the latest controller states
	WPAD_ScanPads();
	
	while(1){

		// Call WPAD_ScanPads each loop, this reads the latest controller states
		WPAD_ScanPads();
		
		GRRLIB_FillScreen(0x0000);				
		
		GRRLIB_ImgPrint(208,410,16,16,"MOTION DEMO",impact_img);
		GRRLIB_ImgPrint(200,430,16,16,"BY SHDWCODER",impact_img);
		
		GRRLIB_ImgPrint(80,192,16,16,"0",impact_img);
		GRRLIB_Line(100, 200, 500, 200, GRRLIB_Conv888_565(0x000000));
		
		GRRLIB_ImgPrint(80,242,16,16,"1",impact_img);
		GRRLIB_Line(100, 250, 500, 250, GRRLIB_Conv888_565(0xaaaaaa));	
		GRRLIB_ImgPrint(80,142,16,16,"1",impact_img);	
		GRRLIB_Line(100, 150, 500, 150, GRRLIB_Conv888_565(0xaaaaaa));
		
		//Get Gforce		
		WPAD_GForce(0, &gforce);
		
		GRRLIB_ImgPrint(142,260,16,16,"X",impact_img);
		drawPoint(150,200-(gforce.x*50),GREEN);
		GRRLIB_ImgPrint(292,260,16,16,"Y",impact_img);
		drawPoint(300,200-(gforce.y*50),RED);
		GRRLIB_ImgPrint(442,260,16,16,"Z",impact_img);
		drawPoint(450,200-(gforce.z*50),BLUE);
		
		PrintFloat(102,280,16,16,gforce.x,impact_img);
		PrintFloat(252,280,16,16,gforce.y,impact_img);
		PrintFloat(402,280,16,16,gforce.z,impact_img);
		
		//Draw cursor
		WPAD_IR(0, &ir);
		WPAD_Orientation(WPAD_CHAN_0, &orient);
		ha = (int)orient.roll;
		if(ha<0){
			ha=360+ha;
		}
		float rad_angle = 2.0*3.14159*ha/360.0;
		GRRLIB_DrawTile(ir.x, ir.y, cursor_width, cursor_high, cursor_img, 0, rad_angle,1 );
		
		if (WPAD_ButtonsDown(0) & WPAD_BUTTON_HOME) {
			GRRLIB_FillScreen(0x0000);
			GRRLIB_ImgPrint(142,200,16,16,"RETURNING TO LOADER...",impact_img);
			GRRLIB_Render();
			exit(0);
		}
		
		u32 held = WPAD_ButtonsHeld(0);

		//Held A will rumble
		if ( held & WPAD_BUTTON_A ){
			WPAD_Rumble(0,1);		
		} else{
			WPAD_Rumble(0,0);		
		}
		
		GRRLIB_Render();
		VIDEO_WaitVSync();
	}

return(0);

}
